from functools import wraps


def log(func):
    @wraps(func)
    def wrapper(*args, **kwargs):
        print(
            f"Calling function {func.__name__} with arguments {args} and kwargs {kwargs}"
        )
        result = func(*args, **kwargs)
        print(f"{func.__name__} returned {result}")
        return result

    return wrapper
